hdu 4114 Disney's FastPass 状压dp+floyd

来源:互联网 发布:百度数据 编辑:程序博客网 时间:2024/05/23 14:47

Problem Description

Disney's FastPass is a virtual queuing system created by the Walt Disney Company. First introduced in 1999 (thugh the idea of a ride reservation system was first introduced in world fairs), Fast-Pass allows guests to avoid long lines at the attractions on which the system is installed, freeing them to enjoy other attractions during their wait. The service is available at no additional charge to all park guests.
--- wikipedia



Disneyland is a large theme park with plenties of entertainment facilities, also with a large number of tourists. Normally, you need to wait for a long time before geting the chance to enjoy any of the attractions. The FastPass is a system allowing you to pick up FastPass-tickets in some specific position, and use them at the corresponding facility to avoid long lines. With the help of the FastPass System, one can arrange his/her trip more efficiently.
You are given the map of the whole park, and there are some attractions that you are interested in. How to visit all the interested attractions within the shortest time?
 

Input
The first line contains an integer T(1<=T<=25), indicating the number of test cases.
Each test case contains several lines.
The first line contains three integers N,M,K(1 <= N <= 50; 0 <= M <= N(N - 1)/2; 0 <= K <= 8), indicating the number of locations(starting with 1, and 1 is the only gate of the park where the trip must be started and ended), the number of roads and the number of interested attractions.
The following M lines each contains three integers A,B,D(1 <= A,B <= N; 0 <= D <= 10^4) which means it takes D minutes to travel between location A and location B.
The following K lines each contains several integers Pi, Ti, FTi,Ni, Fi,1, Fi,2 ... Fi,Ni-1, FiNi ,(1 <= Pi,Ni, Fi,j <=N, 0 <= FTi <= Ti <= 10^4), which means the ith interested araction is placed at location Pi and there are Ni locations Fi,1; Fi,2 ... Fi,Ni where you can get the FastPass for the ith attraction. If you come to the ith attraction with its FastPass, you need to wait for only FTi minutes, otherwise you need to wait for Ti minutes.
You can assume that all the locations are connected and there is at most one road between any two locations.
Note that there might be several attrractions at one location.
 

Output
For each test case in the input, print one line: "Case #X: Y", where X is the test case number (starting with 1) and Y is the minimum time of the trip.
 

Sample Input
24 5 21 2 82 3 43 4 194 1 62 4 72 25 18 1 34 12 6 1 34 6 21 2 51 4 43 1 13 2 13 4 12 4 102 8 3 1 44 8 3 1 2
 

Sample Output
Case #1: 53Case #2: 14


题意:

游戏园里有N个区域,有M条边连接这N个区域,有K个要访问的景点。对于每个景点告诉你这个景点所在的区域,要访问这个景点需要等待一定时间,如果没有FastPass,等待时间有Ti,否则等待时间为FTi,接下来的Ni,表示有Ni个区域可以得到这个景点的FastPass,问从区域1出发,再回到区域1所需要的最少时间。


题意理解错了,等写完了才发现。。。。

这题比较显然的几个状态,数据比较小,大力开数组就行了(   

先floyd求出两点间的距离。

然后设置dp[now][fs][ps]。  now为现在所在的点,fs用状压记录已经获得了哪些快速通道,ps用状压记录已经经过了哪些点。

转移即可。


#include <iostream>#include<bits/stdc++.h>using namespace std;const int INF=0x3f3f3f3f;const int N=55;const int M=1<<8;int n,m,k,mp[N][N],dp[N][M][M],fast[N],p[N],ft[N],t[N];void floyd(){    for(int z=1;z<=n;z++)        for(int i=1;i<=n;i++)            for(int j=1;j<=n;j++)                mp[i][j]=min(mp[i][j],mp[i][z]+mp[z][j]);}int solve(){    int ans=INF;    memset(dp,0x3f,sizeof(dp));    dp[1][0][0]=0;    int ed=1<<k;    for(int ps=0;ps<ed;ps++)        for(int fs=0;fs<ed;fs++)            for(int now=1;now<=n;now++)            {                int t1=dp[now][fs][ps];                if(t1==INF)    continue;                if(ps==ed-1)    ans=min(ans,t1+mp[now][1]);                for(int i=0;i<k;i++)                {                    if(ps&(1<<i))   continue;                    int &t2=dp[p[i]][fast[p[i]]|fs][ps|(1<<i)];                    if(fs&(1<<i))   t2=min(t2,t1+mp[now][p[i]]+ft[i]);                    else    t2=min(t2,t1+mp[now][p[i]]+t[i]);                }                for(int i=1;i<=n;i++)                {                    int &t2=dp[i][fast[i]|fs][ps];                    t2=min(t2,t1+mp[now][i]);                }            }    return ans;}int main(){    int T,kase=0;    cin>>T;    while(T--)    {        scanf("%d%d%d",&n,&m,&k);        memset(mp,0x3f,sizeof(mp));        memset(fast,0,sizeof(fast));        for(int i=1;i<=n;i++)   mp[i][i]=0;        for(int i=1;i<=m;i++)        {            int u1,u2,dis;            scanf("%d%d%d",&u1,&u2,&dis);            mp[u1][u2]=mp[u2][u1]=dis;        }        floyd();        for(int i=0;i<k;i++)        {            int num,tmp;            scanf("%d%d%d%d",&p[i],&t[i],&ft[i],&num);            for(int j=0;j<num;j++)            {                scanf("%d",&tmp);                fast[tmp]|=(1<<i);            }        }        printf("Case #%d: %d\n",++kase,solve());    }}

原创粉丝点击